import os

from django.conf import settings

from kinder import config_parser as config
from kinder import logger

from .order.constants import DEFAULT_ORDER_REQUEST_MESSAGE_TYPE


DEFAULT_CONFIG = {
    ('webservice', 'ATTACHMENT_REQUEST_MESSAGE_TYPE'): 'AttachmentRequest',
    ('webservice', 'ATTACHMENT_REQUEST_MEDIA_HOST'): None,
}

conf = config.ProjectConfig(
    filenames=[
        os.path.normpath(
            os.path.join(settings.CONFIG_PATH, 'concentrator.conf'))
    ],
    defaults=DEFAULT_CONFIG
)

ATTACHMENT_REQUEST_MESSAGE_TYPE = (
    conf.get('webservice', 'ATTACHMENT_REQUEST_MESSAGE_TYPE'))
ATTACHMENT_REQUEST_MEDIA_HOST = (
    conf.get('webservice', 'ATTACHMENT_REQUEST_MEDIA_HOST'))

PLUGIN_DIR_NAME = 'concentrator'
PLUGIN_DIR = os.path.join(settings.PLUGINS_DIR, PLUGIN_DIR_NAME)
PLUGIN_URL = f'{settings.PLUGINS_URL}/{PLUGIN_DIR_NAME}'
if not os.path.exists(PLUGIN_DIR):
    try:
        os.makedirs(PLUGIN_DIR)
    except:
        logger.error("Can't create %s" % PLUGIN_DIR)

# Атрибут, код тестовой среды ЕПГУ для запроса OrderRequest
# (EPGU / UAT / EXUAT / SVCDEV / TCOD / DEV).
# В продуктивной среде возможно только значение «EPGU»
ORDER_REQUEST_SERVICE_ENV = conf.get(
    'webservice', 'ORDER_REQUEST_SERVICE_ENV') or 'DEV'

ORDER_REQUEST_MESSAGE_TYPE = (
    conf.get('webservice', 'ORDER_REQUEST_MESSAGE_TYPE')
    or DEFAULT_ORDER_REQUEST_MESSAGE_TYPE)
